# Name (NameGenerator)

The [Name](/app/generation/generators/generator-reference/name.md) generator generates a random name string from a dictionary of first and last names.

## Link object structure <a href="#generator-api-name-link-object" id="generator-api-name-link-object"></a>

The Name generator cannot be linked. It can be self-consistent, but not consistent with another column. You cannot configure differential privacy.

The `metadata` object is populated from the [`NameClassifierMetadata`](https://app.tonic.ai/apidocs/index.html#/models/NameClassifierMetadata) object, which includes:&#x20;

* The type of name value.
* Whether to preserve the capitalization from the source value.

```json
{
  "schema": "string",
  "table": "string",
  "column": "string",
  "path": "string",  //JSON fields only
  "dataType": "string",  //MongoDB, Amazon DynamoDB, and JSON fields only
  "metadata": {
    "presetId": "string",
    "generatorId": "NameGenerator",
    "nameType": "enum",
    "preserveCapitalization": boolean,
    "isConsistent": boolean,
    "encryptionProcessor": "x-on", //To use configured Structural data encryption
    "customValueProcessor": "string"  //If custom value processor applied
  }
 }
```

## Example replacement <a href="#generator-api-name-replacement" id="generator-api-name-replacement"></a>

In the following example replacement for the Name generator, the name format is Last, First (for example - Smith, John).

Capitalization is preserved.

Consistency is disabled.

```json
{
  "name": "fullname",
  "schema": "public",
  "table": "users",
  "links": [
    {
      "schema": "public",
      "table": "users",
      "column": "fullname",
      "metadata": {
        "presetId": "NameGenerator",
        "generatorId": "NameGenerator",
        "nameType": "LastCommaFirstName",
        "preserveCapitalization": true,
        "isConsistent": false
      }
    }
  ]
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/generator-api-ref-name.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
